import * as i0 from '@angular/core';
import { Component, Input, NgModule } from '@angular/core';
import * as i1 from '@angular/forms';
import { Validators, ReactiveFormsModule, FormsModule } from '@angular/forms';
import * as i2 from '@angular/common';
import { CommonModule } from '@angular/common';
import * as i4 from '@ng-select/ng-select';
import { NgSelectModule } from '@ng-select/ng-select';
import * as i3 from 'ngx-bootstrap/datepicker';
import { BsDatepickerConfig, BsDatepickerModule } from 'ngx-bootstrap/datepicker';

class JsonlogicComponent {
    constructor(fb, cd) {
        this.fb = fb;
        this.cd = cd;
        this.filtered_fieldsList = [];
        this.function = "https://freesvg.org/img/ftfunct.png";
        this.variable = "https://cdn1.iconfinder.com/data/icons/heroicons-ui/24/variable-512.png";
        this.keyboard = "https://upload.wikimedia.org/wikipedia/commons/thumb/e/e4/Keyboard-icon_Wikipedians.svg/1280px-Keyboard-icon_Wikipedians.svg.png";
        this.componentLocation = null;
    }
    ngOnInit() {
        this.filtered_fieldsList = this.fieldsList;
    }
    changeToValue(componentForm) {
        var _a, _b, _c, _d, _e;
        (_a = componentForm.get('controlType')) === null || _a === void 0 ? void 0 : _a.setValue('value');
        (_b = componentForm.get('value')) === null || _b === void 0 ? void 0 : _b.setValue(null);
        componentForm.get('parameters').clear();
        if (this.componentLocation == 'left' && ((_c = componentForm === null || componentForm === void 0 ? void 0 : componentForm.parent) === null || _c === void 0 ? void 0 : _c.get('rightComponent')) != undefined) {
            (_e = (_d = componentForm === null || componentForm === void 0 ? void 0 : componentForm.parent) === null || _d === void 0 ? void 0 : _d.get('fieldtype')) === null || _e === void 0 ? void 0 : _e.setValue(null);
        }
    }
    changeToVariable(componentForm) {
        var _a, _b, _c, _d;
        (_a = componentForm.get('controlType')) === null || _a === void 0 ? void 0 : _a.setValue('variable');
        (_b = componentForm.get('value')) === null || _b === void 0 ? void 0 : _b.setValue(null);
        componentForm.get('parameters').clear();
        if (this.componentLocation == 'left' && ((_c = componentForm.parent) === null || _c === void 0 ? void 0 : _c.get('rightComponent')) != undefined) {
            (_d = componentForm.parent.get('fieldtype')) === null || _d === void 0 ? void 0 : _d.setValue(null);
        }
    }
    changeToFunction(componentForm) {
        var _a, _b, _c, _d;
        (_a = componentForm.get('controlType')) === null || _a === void 0 ? void 0 : _a.setValue('function');
        (_b = componentForm.get('value')) === null || _b === void 0 ? void 0 : _b.setValue(null);
        if (this.componentLocation == 'left' && ((_c = componentForm.parent) === null || _c === void 0 ? void 0 : _c.get('rightComponent')) != undefined) {
            (_d = componentForm.parent.get('fieldtype')) === null || _d === void 0 ? void 0 : _d.setValue(null);
        }
    }
    onSelect(componentForm, controlType) {
        var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t, _u, _v;
        if (controlType != "variable") {
            let selectedfunction = (_a = componentForm.get('value')) === null || _a === void 0 ? void 0 : _a.value;
            let func = this.fieldsList.find(f => f.controlType == "function" && f.value == selectedfunction);
            (_b = componentForm.get('returnType')) === null || _b === void 0 ? void 0 : _b.setValue(func === null || func === void 0 ? void 0 : func.returnType);
            componentForm.get('parameters').clear();
            if (func != undefined) {
                (_c = func.parameters) === null || _c === void 0 ? void 0 : _c.forEach(param => {
                    var _a;
                    if (componentForm.get('padding') != undefined) {
                        param.padding = ((_a = componentForm.get('padding')) === null || _a === void 0 ? void 0 : _a.value) + 20;
                    }
                    componentForm.get('parameters').push(this.componentFormGroup(param));
                });
            }
            if (((_d = componentForm.parent) === null || _d === void 0 ? void 0 : _d.get('rightComponent')) != undefined) {
                (_g = (_f = (_e = componentForm.parent) === null || _e === void 0 ? void 0 : _e.get('rightComponent')) === null || _f === void 0 ? void 0 : _f.get('type')) === null || _g === void 0 ? void 0 : _g.setValue((_h = componentForm.get('returnType')) === null || _h === void 0 ? void 0 : _h.value);
                (_k = (_j = componentForm.parent) === null || _j === void 0 ? void 0 : _j.get('fieldtype')) === null || _k === void 0 ? void 0 : _k.setValue((_l = componentForm.get('returnType')) === null || _l === void 0 ? void 0 : _l.value);
            }
        }
        else {
            let selectedfunction = (_m = componentForm.get('value')) === null || _m === void 0 ? void 0 : _m.value;
            componentForm.get('parameters').clear();
            let func = this.fieldsList.find(f => f.controlType != "function" && f.value == selectedfunction);
            (_o = componentForm.get('type')) === null || _o === void 0 ? void 0 : _o.setValue(func === null || func === void 0 ? void 0 : func.type);
            if (((_p = componentForm.parent) === null || _p === void 0 ? void 0 : _p.get('rightComponent')) != undefined) {
                (_s = (_r = (_q = componentForm.parent) === null || _q === void 0 ? void 0 : _q.get('rightComponent')) === null || _r === void 0 ? void 0 : _r.get('type')) === null || _s === void 0 ? void 0 : _s.setValue((_t = componentForm.get('type')) === null || _t === void 0 ? void 0 : _t.value);
                (_u = componentForm.parent.get('fieldtype')) === null || _u === void 0 ? void 0 : _u.setValue((_v = componentForm.get('type')) === null || _v === void 0 ? void 0 : _v.value);
            }
        }
    }
    componentFormGroup(logic) {
        var _a, _b, _c, _d, _e;
        let group = this.fb.group({
            type: [logic ? logic.type : null],
            value: [logic ? logic.value : null, Validators.required],
            name: [logic ? logic.name : null],
            label: [logic ? logic.label : null],
            controlType: [logic ? logic.controlType : null, Validators.required],
            returnType: [logic ? logic.returnType : null],
            padding: [logic ? logic.padding : null],
            parameters: this.fb.array([]),
        });
        if (logic.parameters) {
            logic.parameters.forEach(param => {
                group.get('parameters').push(this.componentFormGroup(param));
            });
        }
        if (logic) {
            if (logic.name) {
                let optionsal = logic.name[logic.name.length - 1];
                if (optionsal == "?") {
                    (_a = group.get('value')) === null || _a === void 0 ? void 0 : _a.setValidators(([]));
                    (_b = group.get('controlType')) === null || _b === void 0 ? void 0 : _b.setValidators(([]));
                    (_c = group.get('value')) === null || _c === void 0 ? void 0 : _c.updateValueAndValidity();
                    (_d = group.get('controlType')) === null || _d === void 0 ? void 0 : _d.updateValueAndValidity();
                    console.log((_e = group.get('name')) === null || _e === void 0 ? void 0 : _e.value, group.valid);
                }
            }
        }
        return group;
    }
    getPlaceHolder(componentForm) {
        var _a, _b, _c, _d, _e, _f, _g;
        if (((_a = componentForm.get('controlType')) === null || _a === void 0 ? void 0 : _a.value) != 'value') {
            if (((_b = componentForm.get('type')) === null || _b === void 0 ? void 0 : _b.value) == null) {
                return 'Select ' + ((_c = componentForm.get('controlType')) === null || _c === void 0 ? void 0 : _c.value);
            }
            else {
                if (((_d = componentForm.get('name')) === null || _d === void 0 ? void 0 : _d.value) == null) {
                    return 'Select value';
                }
                else {
                    return 'Select ' + ((_e = componentForm.get('name')) === null || _e === void 0 ? void 0 : _e.value);
                }
            }
        }
        else {
            if (((_f = componentForm.get('name')) === null || _f === void 0 ? void 0 : _f.value) == null) {
                return 'Enter value';
            }
            else {
                return 'Enter value for ' + ((_g = componentForm.get('name')) === null || _g === void 0 ? void 0 : _g.value);
            }
        }
    }
    filterlist(componentForm) {
        var _a, _b;
        let controltype = (_a = componentForm.get('controlType')) === null || _a === void 0 ? void 0 : _a.value;
        let type = (_b = componentForm.get('type')) === null || _b === void 0 ? void 0 : _b.value;
        if (type != null) {
            if (type != "string" && type != "text") {
                this.filtered_fieldsList = [...this.fieldsList.filter(x => x.controlType == controltype && (x.returnType == type || x.type == type))];
            }
            else {
                this.filtered_fieldsList = [...this.fieldsList.filter(x => x.controlType == controltype && (x.returnType == "string" || x.returnType == "text" || x.type == "string" || x.type == "text"))];
            }
        }
        else {
            this.filtered_fieldsList = [...this.fieldsList.filter(x => x.controlType == controltype)];
        }
        this.cd.detectChanges();
    }
    showValueTypeControl(componentForm) {
        var _a;
        if (this.componentLocation != 'right' && ((_a = componentForm.parent) === null || _a === void 0 ? void 0 : _a.get('rightComponent')) != undefined) {
            return false;
        }
        else {
            return true;
        }
    }
    disableDateEntry(event, datepicker) {
        if (event.keyCode == 8) {
            datepicker.bsValue = undefined;
        }
        return false;
    }
    checkerror(control) {
        if (control.touched && control.errors != null) {
            return true;
        }
        return false;
    }
}
JsonlogicComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: JsonlogicComponent, deps: [{ token: i1.FormBuilder }, { token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Component });
JsonlogicComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.1.0", type: JsonlogicComponent, selector: "app-jsonlogic", inputs: { form: "form", fieldsList: "fieldsList", componentLocation: "componentLocation" }, ngImport: i0, template: "<ng-container class=\"linemian\" id=\"parent\" *ngTemplateOutlet=\"recursivecomponent;context: {component:form}\">\r\n</ng-container>\r\n<ng-template #recursivecomponent let-componentForm=\"component\">\r\n    <form class=\"componentclass\" [formGroup]=\"componentForm\">\r\n        <table [ngClass]=\"{'empthytable': componentForm.get('controlType')?.value==null}\" class=\"rowm\" [class]=\"'line'+componentForm.get('padding')?.value+'px'\"\r\n            [style.margin-left]=\"componentForm.get('padding')?.value+'px'\" style=\"width: 100%; overflow-x: scroll;\">\r\n            <!-- <table class=\"rowm\" style=\"width: 100%; overflow-x: scroll;\"> -->\r\n              <tr>\r\n                <td>\r\n            <div *ngIf=\"componentForm.get('controlType')?.value==null\" class=\"emptycontrol emptypadding\">\r\n            <p class=\"emptyspace\"> {{this.getPlaceHolder(componentForm)==\"Select null\"?\"\":this.getPlaceHolder(componentForm)}}</p>\r\n            &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;\r\n            </div>\r\n          </td>\r\n              <td>\r\n            <div class=\"col-md-6m paddingleftm inputwidth\" *ngIf=\"componentForm.get('controlType')?.value=='value'\">\r\n                <!-- <input  [placeholder]=\"this.getPlaceHolder(componentForm)\" [type]=\"componentForm.get('type')?.value\"\r\n                    class=\"form-control\" placeholder=\"Enter Some Value\" formControlName=\"value\" /> -->\r\n                <div *ngIf=\"componentForm.get('type')?.value!='date'\">\r\n                    <input [id]=\"componentForm.get('padding')?.value+componentForm.get('name')?.value\" [placeholder]=\"this.getPlaceHolder(componentForm)\" [type]=\"componentForm.get('type')?.value\"\r\n                        class=\"form-controls\" placeholder=\"Enter Some Value\" formControlName=\"value\" />\r\n                </div>\r\n                <div *ngIf=\"componentForm.get('type')?.value=='date'\">\r\n                    <input [id]=\"componentForm.get('padding')?.value+componentForm.get('name')?.value\" (keydown)=\"disableDateEntry($event,expressionDatePicker)\" class=\"form-controls m-input\"\r\n                        type=\"datetime\" bsDatepicker #expressionDatePicker=\"bsDatepicker\" formControlName=\"value\"\r\n                        [bsConfig]=\"{dateInputFormat:'YYYY-MM-DD'}\" />\r\n                </div>\r\n            </div>\r\n          </td\r\n          >\r\n          <td>\r\n            <div class=\"col-md-6m paddingleftm\"\r\n                *ngIf=\"componentForm.get('controlType')?.value=='variable'  || componentForm.get('controlType')?.value=='function'\">\r\n                <ng-select [ngClass]=\"{errorborder: this.checkerror(componentForm.get('value'))}\" [id]=\"componentForm.get('padding')?.value+componentForm.get('name')?.value\" class=\"form-controls\" [items]=\"filtered_fieldsList\" (open)=\"filterlist(componentForm)\"\r\n                    (change)=\"onSelect(componentForm,componentForm.get('controlType')?.value)\" bindLabel=\"label\"\r\n                    [clearable]=\"false\" bindValue=\"value\" [placeholder]=\"this.getPlaceHolder(componentForm)\"\r\n                    formControlName=\"value\">\r\n                </ng-select>\r\n            </div>\r\n          </td>\r\n            <!-- *ngIf=\"componentForm.get('type')?.value!=null\" -->\r\n            <td (click)=\"changeToValue(componentForm)\">\r\n            <div *ngIf=\"showValueTypeControl(componentForm)\" class=\"col-md-2m\"[ngClass]=\"{selectedIcon: componentForm.get('controlType')?.value=='value'}\">\r\n\r\n\r\n              <!-- <i (click)=\"changeToValue(componentForm)\" class=\"fa fa-keyboard\" aria-hidden=\"true\"></i> -->\r\n\r\n              <img [src]=\"keyboard\" [id]=\"componentForm.get('padding')?.value+componentForm.get('name')?.value\" class=\"imgvar imgtyping\" />\r\n\r\n            </div>\r\n          </td>\r\n\r\n          <td (click)=\"changeToVariable(componentForm)\">\r\n            <div  class=\"col-md-2m\" [ngClass]=\"{selectedIcon: componentForm.get('controlType')?.value=='variable'}\">\r\n\r\n                    <img [src]=\"variable\" [id]=\"componentForm.get('padding')?.value+componentForm.get('name')?.value\" class=\"imgvar\" />\r\n            </div>\r\n          </td>\r\n\r\n          <td (click)=\"changeToFunction(componentForm)\">\r\n            <div [ngClass]=\"{errorborder: this.checkerror(componentForm.get('controlType'))}\" class=\"col-md-2m\" [ngClass]=\"{selectedIcon: componentForm.get('controlType')?.value=='function'}\">\r\n\r\n                    <img [src]=\"function\"  [id]=\"componentForm.get('padding')?.value+componentForm.get('name')?.value\" class=\"imgvar imgfunc\" />\r\n            </div>\r\n          </td>\r\n          </tr>\r\n          </table>\r\n        <div class=\"lineone\" *ngIf=\"componentForm.get('parameters')?.value!=undefined\">\r\n            <div class=\"linetwo\" *ngFor=\"let group of componentForm.get('parameters')['controls'];let i=index\">\r\n                <ng-container class=\"linethree\" *ngTemplateOutlet=\"recursivecomponent;context: {component: group}\">\r\n                </ng-container>\r\n            </div>\r\n        </div>\r\n    </form>\r\n</ng-template>\r\n", styles: [".errorborder{border:1px solid red!important;border-radius:5px!important;-webkit-border-radius:5px!important;-moz-border-radius:5px!important;-ms-border-radius:5px!important;-o-border-radius:5px!important}.inputwidth input{width:100%!important;border:1px solid #ccc;padding:4px;border-radius:5px}.inputwidth input:focus{outline:none}.paddingleft{padding-left:0!important;padding-right:0!important}.emptypadding{padding:0!important}.emptyspace{text-align:center;padding-top:3px}.selectedIcon{background-color:#dee2e6!important}.emptycontrol{padding:17px;border:1px solid #e5e5e5;height:36px;max-height:36px;max-width:190px;width:100%;BORDER-RADIUS:4px}.componentclass .row{align-items:center}.componentclass .row .col-md-2{text-align:center}.componentclass .col-md-2{background-color:#f6f6f6;height:36px;align-items:center;display:flex;justify-content:center;border:1px solid #e9e9e9}.componentclass .col-md-2 img{max-width:22px;cursor:pointer}.componentclass .col-md-6.ng-star-inserted{padding:0;height:36px}.componentclass .row{flex-wrap:nowrap}.lineone{margin-top:10px}.imgvar{background-repeat:no-repeat;background-position:center;max-width:30px;height:30px;width:100%;background-size:contain;cursor:pointer}::ng-deep .emptycontrol{max-width:100%!important}.col-md-2m{text-align:center;background-color:#f7f7f7}::ng-deep .tablescroll::-webkit-scrollbar-track{-webkit-box-shadow:inset 0 0 6px rgba(0,0,0,.3);background-color:#fff}::ng-deep .tablescroll::-webkit-scrollbar{width:10px;height:10px;background-color:#717171}::ng-deep .tablescroll::-webkit-scrollbar-thumb{background-color:#717171}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i2.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "directive", type: i1.ɵNgNoValidate, selector: "form:not([ngNoForm]):not([ngNativeValidate])" }, { kind: "directive", type: i1.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i1.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i1.NgControlStatusGroup, selector: "[formGroupName],[formArrayName],[ngModelGroup],[formGroup],form:not([ngNoForm]),[ngForm]" }, { kind: "directive", type: i1.FormGroupDirective, selector: "[formGroup]", inputs: ["formGroup"], outputs: ["ngSubmit"], exportAs: ["ngForm"] }, { kind: "directive", type: i1.FormControlName, selector: "[formControlName]", inputs: ["formControlName", "disabled", "ngModel"], outputs: ["ngModelChange"] }, { kind: "directive", type: i3.BsDatepickerDirective, selector: "[bsDatepicker]", inputs: ["placement", "triggers", "outsideClick", "container", "outsideEsc", "isDisabled", "minDate", "maxDate", "minMode", "daysDisabled", "datesDisabled", "datesEnabled", "dateCustomClasses", "dateTooltipTexts", "isOpen", "bsValue", "bsConfig"], outputs: ["onShown", "onHidden", "bsValueChange"], exportAs: ["bsDatepicker"] }, { kind: "directive", type: i3.BsDatepickerInputDirective, selector: "input[bsDatepicker]" }, { kind: "component", type: i4.NgSelectComponent, selector: "ng-select", inputs: ["bindLabel", "bindValue", "markFirst", "placeholder", "notFoundText", "typeToSearchText", "addTagText", "loadingText", "clearAllText", "appearance", "dropdownPosition", "appendTo", "loading", "closeOnSelect", "hideSelected", "selectOnTab", "openOnEnter", "maxSelectedItems", "groupBy", "groupValue", "bufferAmount", "virtualScroll", "selectableGroup", "selectableGroupAsModel", "searchFn", "trackByFn", "clearOnBackspace", "labelForId", "inputAttrs", "tabIndex", "readonly", "searchWhileComposing", "minTermLength", "editableSearchTerm", "keyDownFn", "typeahead", "multiple", "addTag", "searchable", "clearable", "isOpen", "items", "compareWith", "clearSearchOnAdd"], outputs: ["blur", "focus", "change", "open", "close", "search", "clear", "add", "remove", "scroll", "scrollToEnd"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: JsonlogicComponent, decorators: [{
            type: Component,
            args: [{ selector: 'app-jsonlogic', template: "<ng-container class=\"linemian\" id=\"parent\" *ngTemplateOutlet=\"recursivecomponent;context: {component:form}\">\r\n</ng-container>\r\n<ng-template #recursivecomponent let-componentForm=\"component\">\r\n    <form class=\"componentclass\" [formGroup]=\"componentForm\">\r\n        <table [ngClass]=\"{'empthytable': componentForm.get('controlType')?.value==null}\" class=\"rowm\" [class]=\"'line'+componentForm.get('padding')?.value+'px'\"\r\n            [style.margin-left]=\"componentForm.get('padding')?.value+'px'\" style=\"width: 100%; overflow-x: scroll;\">\r\n            <!-- <table class=\"rowm\" style=\"width: 100%; overflow-x: scroll;\"> -->\r\n              <tr>\r\n                <td>\r\n            <div *ngIf=\"componentForm.get('controlType')?.value==null\" class=\"emptycontrol emptypadding\">\r\n            <p class=\"emptyspace\"> {{this.getPlaceHolder(componentForm)==\"Select null\"?\"\":this.getPlaceHolder(componentForm)}}</p>\r\n            &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;\r\n            </div>\r\n          </td>\r\n              <td>\r\n            <div class=\"col-md-6m paddingleftm inputwidth\" *ngIf=\"componentForm.get('controlType')?.value=='value'\">\r\n                <!-- <input  [placeholder]=\"this.getPlaceHolder(componentForm)\" [type]=\"componentForm.get('type')?.value\"\r\n                    class=\"form-control\" placeholder=\"Enter Some Value\" formControlName=\"value\" /> -->\r\n                <div *ngIf=\"componentForm.get('type')?.value!='date'\">\r\n                    <input [id]=\"componentForm.get('padding')?.value+componentForm.get('name')?.value\" [placeholder]=\"this.getPlaceHolder(componentForm)\" [type]=\"componentForm.get('type')?.value\"\r\n                        class=\"form-controls\" placeholder=\"Enter Some Value\" formControlName=\"value\" />\r\n                </div>\r\n                <div *ngIf=\"componentForm.get('type')?.value=='date'\">\r\n                    <input [id]=\"componentForm.get('padding')?.value+componentForm.get('name')?.value\" (keydown)=\"disableDateEntry($event,expressionDatePicker)\" class=\"form-controls m-input\"\r\n                        type=\"datetime\" bsDatepicker #expressionDatePicker=\"bsDatepicker\" formControlName=\"value\"\r\n                        [bsConfig]=\"{dateInputFormat:'YYYY-MM-DD'}\" />\r\n                </div>\r\n            </div>\r\n          </td\r\n          >\r\n          <td>\r\n            <div class=\"col-md-6m paddingleftm\"\r\n                *ngIf=\"componentForm.get('controlType')?.value=='variable'  || componentForm.get('controlType')?.value=='function'\">\r\n                <ng-select [ngClass]=\"{errorborder: this.checkerror(componentForm.get('value'))}\" [id]=\"componentForm.get('padding')?.value+componentForm.get('name')?.value\" class=\"form-controls\" [items]=\"filtered_fieldsList\" (open)=\"filterlist(componentForm)\"\r\n                    (change)=\"onSelect(componentForm,componentForm.get('controlType')?.value)\" bindLabel=\"label\"\r\n                    [clearable]=\"false\" bindValue=\"value\" [placeholder]=\"this.getPlaceHolder(componentForm)\"\r\n                    formControlName=\"value\">\r\n                </ng-select>\r\n            </div>\r\n          </td>\r\n            <!-- *ngIf=\"componentForm.get('type')?.value!=null\" -->\r\n            <td (click)=\"changeToValue(componentForm)\">\r\n            <div *ngIf=\"showValueTypeControl(componentForm)\" class=\"col-md-2m\"[ngClass]=\"{selectedIcon: componentForm.get('controlType')?.value=='value'}\">\r\n\r\n\r\n              <!-- <i (click)=\"changeToValue(componentForm)\" class=\"fa fa-keyboard\" aria-hidden=\"true\"></i> -->\r\n\r\n              <img [src]=\"keyboard\" [id]=\"componentForm.get('padding')?.value+componentForm.get('name')?.value\" class=\"imgvar imgtyping\" />\r\n\r\n            </div>\r\n          </td>\r\n\r\n          <td (click)=\"changeToVariable(componentForm)\">\r\n            <div  class=\"col-md-2m\" [ngClass]=\"{selectedIcon: componentForm.get('controlType')?.value=='variable'}\">\r\n\r\n                    <img [src]=\"variable\" [id]=\"componentForm.get('padding')?.value+componentForm.get('name')?.value\" class=\"imgvar\" />\r\n            </div>\r\n          </td>\r\n\r\n          <td (click)=\"changeToFunction(componentForm)\">\r\n            <div [ngClass]=\"{errorborder: this.checkerror(componentForm.get('controlType'))}\" class=\"col-md-2m\" [ngClass]=\"{selectedIcon: componentForm.get('controlType')?.value=='function'}\">\r\n\r\n                    <img [src]=\"function\"  [id]=\"componentForm.get('padding')?.value+componentForm.get('name')?.value\" class=\"imgvar imgfunc\" />\r\n            </div>\r\n          </td>\r\n          </tr>\r\n          </table>\r\n        <div class=\"lineone\" *ngIf=\"componentForm.get('parameters')?.value!=undefined\">\r\n            <div class=\"linetwo\" *ngFor=\"let group of componentForm.get('parameters')['controls'];let i=index\">\r\n                <ng-container class=\"linethree\" *ngTemplateOutlet=\"recursivecomponent;context: {component: group}\">\r\n                </ng-container>\r\n            </div>\r\n        </div>\r\n    </form>\r\n</ng-template>\r\n", styles: [".errorborder{border:1px solid red!important;border-radius:5px!important;-webkit-border-radius:5px!important;-moz-border-radius:5px!important;-ms-border-radius:5px!important;-o-border-radius:5px!important}.inputwidth input{width:100%!important;border:1px solid #ccc;padding:4px;border-radius:5px}.inputwidth input:focus{outline:none}.paddingleft{padding-left:0!important;padding-right:0!important}.emptypadding{padding:0!important}.emptyspace{text-align:center;padding-top:3px}.selectedIcon{background-color:#dee2e6!important}.emptycontrol{padding:17px;border:1px solid #e5e5e5;height:36px;max-height:36px;max-width:190px;width:100%;BORDER-RADIUS:4px}.componentclass .row{align-items:center}.componentclass .row .col-md-2{text-align:center}.componentclass .col-md-2{background-color:#f6f6f6;height:36px;align-items:center;display:flex;justify-content:center;border:1px solid #e9e9e9}.componentclass .col-md-2 img{max-width:22px;cursor:pointer}.componentclass .col-md-6.ng-star-inserted{padding:0;height:36px}.componentclass .row{flex-wrap:nowrap}.lineone{margin-top:10px}.imgvar{background-repeat:no-repeat;background-position:center;max-width:30px;height:30px;width:100%;background-size:contain;cursor:pointer}::ng-deep .emptycontrol{max-width:100%!important}.col-md-2m{text-align:center;background-color:#f7f7f7}::ng-deep .tablescroll::-webkit-scrollbar-track{-webkit-box-shadow:inset 0 0 6px rgba(0,0,0,.3);background-color:#fff}::ng-deep .tablescroll::-webkit-scrollbar{width:10px;height:10px;background-color:#717171}::ng-deep .tablescroll::-webkit-scrollbar-thumb{background-color:#717171}\n"] }]
        }], ctorParameters: function () { return [{ type: i1.FormBuilder }, { type: i0.ChangeDetectorRef }]; }, propDecorators: { form: [{
                type: Input
            }], fieldsList: [{
                type: Input
            }], componentLocation: [{
                type: Input
            }] } });

class JsonlogicExpressionEditorComponent {
    constructor(fb) {
        this.fb = fb;
        this.variables = [];
        this.functions = [];
        this.plus = "https://cdn0.iconfinder.com/data/icons/ui-16px-perfect-megapack-line/16/82_Add-512.png";
        this.minus = "https://toppng.com/uploads/preview/free-recycle-bin-icon-vector-recycle-bin-icon-115534132079jvhnualpn.png";
        this.JsonLogicObj = {};
        this.checklistTemplateItemExpressions = [];
        this.filtered_operatorList = [];
        this.operatorList = [
            {
                type: ['number', 'text', 'string', 'date'],
                label: 'Equals',
                value: '=='
            },
            {
                type: ['number', 'date'],
                label: 'Not Equal',
                value: '!='
            },
            {
                type: ['number', 'date'],
                label: 'Greator Then',
                value: '>'
            },
            {
                type: ['number', 'date'],
                label: 'Less Then',
                value: '<'
            },
            {
                type: ['number', 'date'],
                label: 'Greator Then Equals',
                value: '>='
            },
            {
                type: ['number', 'date'],
                label: 'Less Then Equals',
                value: '<='
            },
            {
                type: ['text', 'string'],
                label: 'In',
                value: 'in'
            }
        ];
        this.expressionformArray = this.fb.array([]);
        this.logicalOperatorList = [
            {
                label: 'And',
                value: 1
            },
            {
                label: 'Or',
                value: 0
            }
        ];
    }
    ngAfterViewInit() {
    }
    ngOnInit() {
        this.filtered_operatorList = this.operatorList;
        this.constructModelLogic();
        //this.constructFormArray();
    }
    mergeFunctionIntoVariables() {
        this.functions.forEach(f => {
            f.label = 'f(X) ' + f.name;
            f.value = f.name;
            this.variables.push(f);
        });
    }
    SetttingsForVariableAndFunctions(functions) {
        functions === null || functions === void 0 ? void 0 : functions.forEach(f => {
            var _a;
            if ((_a = f.parameters) === null || _a === void 0 ? void 0 : _a.length) {
                this.SetttingsForVariableAndFunctions(f.parameters);
            }
            else {
                if (f.controlType == "variable") {
                    f.returnType = null;
                }
                if (f.controlType == "function") {
                    f.type = null;
                }
            }
        });
    }
    constructModelLogic() {
        // let json_logic = `{"and":[{"==":[{"var":"Name"},{"cat":["farrukh ","khan"]}]}]}`;
        // let json_logic = `{"and":[{"==":[{"cat":["farrukh ","khan"]},{"var":"Name"}]}]}`;
        //let json_logic = `{"and":[{"in":[{"var":"SubjectLastName"},{"var":"ParentSubjectName"}]},{"and":[{"==":[{"var":"Name"},{"cat":["farrukh ","khan"]}]}]}]}`;
        this.mergeFunctionIntoVariables();
        if (this.jsonLogic != null && this.jsonLogic != '') {
            let jsonlogicObj = JSON.parse(this.jsonLogic);
            let modelLogic = {};
            this.expressionformArray.clear();
            this.checklistTemplateItemExpressions = [];
            this.checklistTemplateItemExpressions.push(this.parseJsonLogic(jsonlogicObj, modelLogic));
            this.constructFormArray();
            sessionStorage.setItem("model_LOGIC", JSON.stringify(modelLogic));
        }
        else {
            let exp = {};
            exp.id = 0;
            exp.leftComponent = null;
            exp.rightComponent = null;
            exp.logicalOperator = 1;
            exp.field = null;
            exp.transactionType = 1;
            exp.operator = null;
            exp.value = null;
            this.expressionformArray.push(this.add_checkExpressionFormGroup(exp));
        }
    }
    parseJsonLogic(Jobj, logic) {
        let keys = Object.keys(Jobj);
        let key = keys[0];
        if (key == "and" || key == "or") {
            logic.logicalOperator = this.getLogicalOperatorValue(key);
            // and: []
            Object.keys(Jobj[key]).forEach((k, i) => {
                let keys = Object.keys(Jobj[key][k]); //   JObj["and"]["0"]  ==  {  "==":[      ]     }
                let operatorkey = keys[0];
                //  Jobj[key][k][operatorkey]=    [   {"var":"Name"},   {"cat":["farrukh ","khan"]}    ]
                // Jobj[and][0][==]            =[   {"var":"Name"},   {"cat":["farrukh ","khan"]}    ]
                if (operatorkey == "and" || operatorkey == "or") {
                    let sublogic = {};
                    sublogic.operator = Object.keys(Jobj[key][i][operatorkey][0])[0];
                    this.checklistTemplateItemExpressions.push(this.parseJsonLogic(Jobj[key][i], sublogic));
                }
                else {
                    logic.operator = operatorkey;
                    Jobj[key][k][operatorkey].forEach((obj, i) => {
                        if (i == 0) {
                            logic.leftComponent = {};
                            logic.leftComponent = this.parseComponentLogic(obj, logic.leftComponent);
                            if (logic.leftComponent.type == "text" || logic.leftComponent.type == "string" || logic.leftComponent.returnType == "text" || logic.leftComponent.returnType == "string") {
                                logic.fieldType = "string";
                            }
                            else {
                                if (logic.leftComponent.type != null) {
                                    logic.fieldType = logic.leftComponent.type;
                                }
                                else {
                                    logic.fieldType = logic.leftComponent.returnType;
                                }
                            }
                        }
                        if (i == 1) {
                            logic.rightComponent = {};
                            logic.rightComponent = this.parseComponentLogic(obj, logic.rightComponent);
                            logic.rightComponent.type = logic.fieldType;
                        }
                    });
                }
            });
        }
        // if (key == "var") {
        // }
        // if (this.operatorList.find(op => op.value == key) != undefined) {
        // }
        // else {
        // }
        return logic;
    }
    parseComponentLogic(Jobj, component, name = null, padding = 20) {
        if (Jobj == null) {
            component.controlType = null;
            component.value = Jobj;
            component.padding = padding;
            component.returnType = null;
            component.label = null;
            component.name = name;
            component.parameters = [];
            return component;
        }
        let keys = Object.keys(Jobj);
        let key = null;
        if (keys.length) {
            key = keys[0];
        }
        if (typeof (Jobj) == 'string') {
            // its a string   control type value
            if (this.IsISODate(Jobj)) {
                component.type = 'date';
            }
            else if (isNaN(Number(Jobj)) == false) {
                component.type = 'number';
            }
            else {
                component.type = 'string';
            }
            component.controlType = "value";
            component.value = Jobj;
            component.padding = padding;
            component.returnType = null;
            component.label = null;
            component.name = name;
            component.parameters = [];
        }
        else if (key == "var") {
            // its a variable  control type  variable
            let chosenVar = this.variables.find(x => x.value == Jobj[key]);
            component.type = chosenVar.type;
            component.value = chosenVar.value;
            component.label = null;
            component.name = name;
            component.returnType = null;
            component.controlType = "variable";
            component.padding = padding;
            component.parameters = [];
        }
        else if (key != 'var') {
            let chosenFunc = this.variables.find(x => x.value == key);
            component.type = null; //chosenFunc.type;
            component.value = chosenFunc.value;
            component.label = null;
            component.name = name ? name : chosenFunc.name;
            component.returnType = chosenFunc.returnType;
            component.controlType = "function";
            component.padding = padding;
            component.parameters = [];
            Jobj[key].forEach((obj, i) => {
                var _a;
                let param = {};
                let padding = component.padding + 20;
                (_a = component.parameters) === null || _a === void 0 ? void 0 : _a.push(this.parseComponentLogic(obj, param, chosenFunc === null || chosenFunc === void 0 ? void 0 : chosenFunc.parameters[i].name, padding));
            });
            // its a function
        }
        return component;
    }
    constructFormArray() {
        this.checklistTemplateItemExpressions.forEach(exp => this.expressionformArray.push(this.add_checkExpressionFormGroup(exp)));
    }
    add_checkExpressionFormGroup(exp) {
        let group = this.fb.group({
            id: [exp ? exp.id : 0],
            logicalOperator: [exp ? exp.logicalOperator : null],
            leftComponent: this.componentFormGroup(exp.leftComponent),
            operator: [exp ? exp.operator : null, Validators.required],
            rightComponent: this.componentFormGroup(exp.rightComponent),
            fieldtype: [exp ? exp.fieldType : null],
            transactionType: [this.getTransactionType(exp)],
        });
        if (exp) {
            if (exp.field != null) {
                let field = this.variables.find(x => x.value == exp.field);
                this.setValueType(field.type, group);
            }
        }
        return group;
    }
    componentFormGroup(logic) {
        var _a, _b, _c, _d;
        let group = this.fb.group({
            type: [logic ? logic.type : null],
            value: [logic ? logic.value : null, Validators.required],
            label: [logic ? logic.label : null],
            name: [logic ? logic.name : null],
            returnType: [logic ? logic.returnType : null],
            controlType: [logic ? logic.controlType : null, Validators.required],
            padding: [logic ? logic.padding : 20],
            parameters: this.fb.array([]),
        });
        if (logic === null || logic === void 0 ? void 0 : logic.parameters) {
            logic.parameters.forEach(param => {
                group.get('parameters').push(this.componentFormGroup(param));
            });
        }
        if (logic) {
            if (logic.name) {
                let optional = logic.name[logic.name.length - 1];
                if (optional == "?") {
                    (_a = group.get('value')) === null || _a === void 0 ? void 0 : _a.clearValidators();
                    (_b = group.get('value')) === null || _b === void 0 ? void 0 : _b.updateValueAndValidity();
                    (_c = group.get('controlType')) === null || _c === void 0 ? void 0 : _c.clearValidators();
                    (_d = group.get('controlType')) === null || _d === void 0 ? void 0 : _d.updateValueAndValidity();
                }
            }
        }
        return group;
    }
    addCheckExpression(i) {
        let exp = {};
        exp.id = 0;
        exp.logicalOperator = 1;
        exp.field = null;
        exp.transactionType = 1;
        exp.leftComponent = null;
        exp.rightComponent = null;
        exp.operator = null;
        exp.value = null;
        if (this.expressionformArray.length == 1) {
            this.expressionformArray.push(this.add_checkExpressionFormGroup(exp));
        }
        else {
            this.expressionformArray.insert(i + 1, this.add_checkExpressionFormGroup(exp));
        }
    }
    removecheckExpresssion(i, group) {
        this.deleteExpression(i);
    }
    deleteExpression(i) {
        var _a;
        this.expressionformArray.removeAt(i);
        if (this.expressionformArray.length == 1) {
            let expression = this.expressionformArray.at(0);
            (_a = expression.get('LogicalOperator')) === null || _a === void 0 ? void 0 : _a.setValue(null);
        }
    }
    filterOperatorList(i) {
        this.filtered_operatorList = [];
        let expression = this.expressionformArray.at(i);
        let type = this.getLeftComponentType(expression);
        this.operatorList.forEach(op => {
            op.type.forEach(t => {
                if (t == type) {
                    this.filtered_operatorList.push(op);
                }
            });
        });
    }
    getLeftComponentType(expression) {
        var _a, _b, _c, _d;
        let leftComponent = expression.get('leftComponent');
        let type = null;
        if (((_a = leftComponent.get('type')) === null || _a === void 0 ? void 0 : _a.value) != null) {
            type = (_b = leftComponent.get('type')) === null || _b === void 0 ? void 0 : _b.value;
        }
        if (((_c = leftComponent.get('returnType')) === null || _c === void 0 ? void 0 : _c.value) != null) {
            type = (_d = leftComponent.get('returnType')) === null || _d === void 0 ? void 0 : _d.value;
        }
        return type;
    }
    getTransactionType(exp) {
        if (exp) {
            if (exp.transactionType == null) {
                return 1;
            }
            else if (exp.transactionType == 0) {
                return 2;
            }
            else {
                return exp.transactionType;
            }
        }
        else {
            return 1;
        }
    }
    setValueType(type, expression) {
        if (type == "string" || type == "text") {
            expression.get('fieldtype').setValue('text');
        }
        if (type == "number") {
            expression.get('fieldtype').setValue('number');
        }
        if (type == 'date') {
            expression.get('fieldtype').setValue('date');
        }
    }
    getJsonLogic() {
        if (!this.expressionformArray.valid) {
            this.expressionformArray.markAllAsTouched();
            return;
        }
        this.expressionformArray.controls.forEach(exp => {
            var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t, _u, _v, _w, _x, _y;
            if (((_a = exp.get('transactionType')) === null || _a === void 0 ? void 0 : _a.value) != 3) {
                if (this.JsonLogicObj == null) {
                    this.JsonLogicObj = {};
                    this.JsonLogicObj[this.getLogicalOperatorKey((_b = exp.get('logicalOperator')) === null || _b === void 0 ? void 0 : _b.value)] = [];
                    let nestedobj = {};
                    nestedobj[(_c = exp.get('operator')) === null || _c === void 0 ? void 0 : _c.value] = [];
                    // left component
                    nestedobj[(_d = exp.get('operator')) === null || _d === void 0 ? void 0 : _d.value].push(this.generateExpression(exp.get('leftComponent'), (_f = (_e = exp.get('leftComponent')) === null || _e === void 0 ? void 0 : _e.get('controlType')) === null || _f === void 0 ? void 0 : _f.value, (_g = exp.get('fieldtype')) === null || _g === void 0 ? void 0 : _g.value));
                    //right
                    nestedobj[(_h = exp.get('operator')) === null || _h === void 0 ? void 0 : _h.value].push(this.generateExpression(exp.get('rightComponent'), (_k = (_j = exp.get('rightComponent')) === null || _j === void 0 ? void 0 : _j.get('controlType')) === null || _k === void 0 ? void 0 : _k.value, (_l = exp.get('fieldtype')) === null || _l === void 0 ? void 0 : _l.value));
                    this.JsonLogicObj[this.getLogicalOperatorKey((_m = exp.get('logicalOperator')) === null || _m === void 0 ? void 0 : _m.value)].push(nestedobj);
                }
                else {
                    let obj = {};
                    obj[this.getLogicalOperatorKey((_o = exp.get('logicalOperator')) === null || _o === void 0 ? void 0 : _o.value)] = [];
                    let nestedobj = {};
                    nestedobj[(_p = exp.get('operator')) === null || _p === void 0 ? void 0 : _p.value] = [];
                    //left
                    nestedobj[(_q = exp.get('operator')) === null || _q === void 0 ? void 0 : _q.value].push(this.generateExpression(exp.get('leftComponent'), (_s = (_r = exp.get('leftComponent')) === null || _r === void 0 ? void 0 : _r.get('controlType')) === null || _s === void 0 ? void 0 : _s.value, (_t = exp.get('fieldtype')) === null || _t === void 0 ? void 0 : _t.value));
                    //right
                    nestedobj[(_u = exp.get('operator')) === null || _u === void 0 ? void 0 : _u.value].push(this.generateExpression(exp.get('rightComponent'), (_w = (_v = exp.get('rightComponent')) === null || _v === void 0 ? void 0 : _v.get('controlType')) === null || _w === void 0 ? void 0 : _w.value, (_x = exp.get('fieldtype')) === null || _x === void 0 ? void 0 : _x.value));
                    obj[this.getLogicalOperatorKey((_y = exp.get('logicalOperator')) === null || _y === void 0 ? void 0 : _y.value)].push(nestedobj);
                    // obj[this.getLogicalOperatorKey(exp.get('logicalOperator')?.value)].push(this.JsonLogicObj);
                    //Object.assign(this.JsonLogicObj,obj);
                    this.JsonLogicObj = Object.assign({}, obj);
                }
            }
        });
        let JSON_lOGIC = JSON.stringify(this.JsonLogicObj);
        sessionStorage.setItem('logiccccc', JSON_lOGIC);
        return JSON_lOGIC;
    }
    // getJsonLogic() {
    //     this.expressionformArray.controls.forEach(exp => {
    //         if (exp.get('transactionType')?.value != 3) {
    //             if (this.JsonLogicObj == null) {
    //                 this.JsonLogicObj = {} as any;
    //                 this.JsonLogicObj[this.getLogicalOperatorKey(exp.get('logicalOperator')?.value)]= [];
    //                 let nestedobj = {}  as  any;
    //                 nestedobj[exp.get('operator')?.value] = [];
    //                 // left component
    //                 nestedobj[exp.get('operator')?.value].push(
    //                     this.generateExpression(<FormGroup>exp.get('leftComponent'), exp.get('leftComponent')?.get('controlType')?.value, exp.get('fieldtype')?.value)
    //                 );
    //                 //right
    //                 nestedobj[exp.get('operator')?.value].push(
    //                     this.generateExpression(<FormGroup>exp.get('rightComponent'), exp.get('rightComponent')?.get('controlType')?.value, exp.get('fieldtype')?.value)
    //                 );
    //                 this.JsonLogicObj[this.getLogicalOperatorKey(exp.get('logicalOperator')?.value)].push(nestedobj);
    //               }
    //             else {
    //                 let obj :any= {};
    //                 obj[this.getLogicalOperatorKey(exp.get('logicalOperator')?.value)] = [];
    //                 let nestedobj = {} as any;
    //                 nestedobj[exp.get('operator')?.value] = [];
    //                 //left
    //                 nestedobj[exp.get('operator')?.value].push(
    //                     this.generateExpression(<FormGroup>exp.get('leftComponent'), exp.get('leftComponent')?.get('controlType')?.value, exp.get('fieldtype')?.value)
    //                 );
    //                 //right
    //                 nestedobj[exp.get('operator')?.value].push(
    //                     this.generateExpression(<FormGroup>exp.get('rightComponent'), exp.get('rightComponent')?.get('controlType')?.value, exp.get('fieldtype')?.value)
    //                 );
    //                 obj[this.getLogicalOperatorKey(exp.get('logicalOperator')?.value)].push(nestedobj);
    //                 obj[this.getLogicalOperatorKey(exp.get('logicalOperator')?.value)].push(this.JsonLogicObj);
    //                 this.JsonLogicObj = { ...obj };
    //             }
    //         }
    //     });
    //     let JSON_lOGIC = JSON.stringify(this.JsonLogicObj);
    //     sessionStorage.setItem('logiccccc', JSON_lOGIC);
    //     return JSON_lOGIC;
    // }
    generateExpression(group, controlType, fieldtype) {
        var _a, _b, _c, _d;
        if (controlType == "function") {
            let nestedObj = {};
            nestedObj[(_a = group.get('value')) === null || _a === void 0 ? void 0 : _a.value] = [];
            let params = group.get('parameters');
            params.controls.forEach(g => {
                var _a, _b, _c, _d, _e;
                if (((_a = g.get('controlType')) === null || _a === void 0 ? void 0 : _a.value) == null) {
                    nestedObj[(_b = group.get('value')) === null || _b === void 0 ? void 0 : _b.value].push(null);
                }
                else {
                    let nested = this.generateExpression(g, (_c = g.get('controlType')) === null || _c === void 0 ? void 0 : _c.value, (_d = g.get('type')) === null || _d === void 0 ? void 0 : _d.value);
                    nestedObj[(_e = group.get('value')) === null || _e === void 0 ? void 0 : _e.value].push(nested);
                }
            });
            return nestedObj;
        }
        if (controlType == "variable") {
            return { 'var': (_b = group.get('value')) === null || _b === void 0 ? void 0 : _b.value };
        }
        if (controlType == "value") {
            if (fieldtype == "date") {
                let date = new Date((_c = group.get('value')) === null || _c === void 0 ? void 0 : _c.value).toISOString();
                return date.split('T')[0];
            }
            else {
                return (_d = group.get('value')) === null || _d === void 0 ? void 0 : _d.value;
            }
        }
    }
    getLogicalOperatorKey(lo) {
        if (lo == null || lo == 1) {
            return "and";
        }
        if (lo == 0) {
            return "or";
        }
        return lo;
    }
    getLogicalOperatorValue(key) {
        if (key == "and") {
            return 1;
        }
        else {
            return 0;
        }
    }
    IsISODate(date) {
        let regex = new RegExp('^\d{4}-([0]\d|1[0-2]){1,2}-([0-2]\d|3[01])$');
        return regex.test(date);
    }
    getFormGroup(group) {
        return group;
    }
    consolelogic() {
        console.log(this.getJsonLogic());
    }
    checkerror(control) {
        if (control.touched && control.errors != null) {
            return true;
        }
        return false;
    }
}
JsonlogicExpressionEditorComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: JsonlogicExpressionEditorComponent, deps: [{ token: i1.FormBuilder }], target: i0.ɵɵFactoryTarget.Component });
JsonlogicExpressionEditorComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.1.0", type: JsonlogicExpressionEditorComponent, selector: "jsonlogic-expression-editor", inputs: { jsonLogic: "jsonLogic", variables: "variables", functions: "functions" }, ngImport: i0, template: "<div class=\"col-md-12\">\r\n    <!-- <div class=\"row\">\r\n        <div class=\"col-md-1\">&nbsp;</div>\r\n        <div class=\"col-md-1 text-center\">And/Or</div>\r\n        <div class=\"col-md-4 text-center\">Field *</div>\r\n        <div class=\"col-md-1 text-center\">Operator *</div>\r\n        <div class=\"col-md-5 text-center\">Value *</div>\r\n    </div> -->\r\n    <div class=\"formMargin\" *ngFor=\"let group of expressionformArray['controls'];let i=index\">\r\n        <div [formGroup]=\"this.getFormGroup(group)\">\r\n            <div class=\"row toprow\">\r\n              <div class=\"col-md-4 noPadding text-center logicaloperator\">\r\n                <div class=\"labelAdd\">\r\n                  <img [src]=\"plus\" class=\"imgbtn imgadd\" (click)=\"addCheckExpression(i)\"/> <span style=\"font-size: 20px;\">And/Or</span>\r\n                </div>\r\n                <div *ngIf=\"i!=0\">\r\n                  <ng-select class=\"form-controls\" [id]=\"'logicaloperator'+i\" [items]=\"logicalOperatorList\"\r\n                      ngDefaultControl bindLabel=\"label\" [clearable]=\"false\" bindValue=\"value\"\r\n                      placeholder=\"And/Or\" formControlName=\"logicalOperator\">\r\n                  </ng-select>\r\n              </div>\r\n\r\n            </div>\r\n\r\n            <div class=\"col-md-4 tw0select\">\r\n                <!-- <div *ngIf=\"i==0\">&nbsp;</div> -->\r\n\r\n                <ng-select [ngClass]=\"{errorborder: this.checkerror(group.get('operator'))}\" (open)=\"filterOperatorList(i)\" class=\"form-controls\" [id]=\"'operator'+i\"\r\n                [items]=\"filtered_operatorList\" bindLabel=\"label\" [clearable]=\"false\" bindValue=\"value\"\r\n                placeholder=\"operator\" formControlName=\"operator\">\r\n            </ng-select>\r\n            </div>\r\n            <div class=\"col-md-4\" >\r\n\r\n\r\n              <div class=\"labelRemove\" *ngIf=\"expressionformArray['length']>1\">\r\n                <img [src]=\"minus\" class=\"imgbtn imgminus\" (click)=\"removecheckExpresssion(i,group)\"/>\r\n        </div>\r\n          </div>\r\n\r\n            </div>\r\n            <div class=\"row bottomrow\">\r\n\r\n\r\n                <div class=\"col-md-6\" [ngClass]=\"{'tablescroll': group?.get('leftComponent')?.get('parameters')?.value?.length>0}\"  *ngIf=\"group?.get('leftComponent')!=undefined\">\r\n                  <table style=\"width: 100%; overflow:scroll;\">\r\n                    <app-jsonlogic  [componentLocation]=\"'left'\" [fieldsList]=\"variables\"\r\n                        [form]=\"this.getFormGroup(group.get('leftComponent'))\">\r\n                    </app-jsonlogic>\r\n                  </table>\r\n                </div>\r\n\r\n\r\n                <div class=\"col-md-6\" [ngClass]=\"{'tablescroll': group?.get('rightComponent')?.get('parameters')?.value?.length>0}\"  *ngIf=\"group.get('fieldtype')?.value!=null && group?.get('rightComponent')!=undefined \">\r\n                   <table style=\"width: 100%; overflow:scroll;\">\r\n                    <app-jsonlogic #jsoneditor [componentLocation]=\"'right'\" [fieldsList]=\"variables\"\r\n                        [form]=\"this.getFormGroup(group.get('rightComponent'))\">\r\n                    </app-jsonlogic>\r\n                  </table>\r\n                </div>\r\n            </div>\r\n        </div>\r\n    </div>\r\n</div>\r\n", styles: [".errorborder{border:1px solid red!important;border-radius:5px!important;-webkit-border-radius:5px!important;-moz-border-radius:5px!important;-ms-border-radius:5px!important;-o-border-radius:5px!important}.col-md-1.noPadding.text-center{display:flex;justify-content:space-evenly}::ng-deep jsonlogic-expression-editor{margin:20px;display:block}.formMargin{width:100%}.labelAdd,.labelRemove{width:30px;height:30px}.imgbtn{background-repeat:no-repeat;background-position:center;max-width:30px;height:30px;width:100%;background-size:contain;cursor:pointer;position:relative;display:block;margin-inline:10px}.lineone input.form-controls.ng-untouched.ng-pristine.ng-valid{padding:5px 10px;color:#333;background-color:#fff;border-radius:4px;border:1px solid #ccc;min-height:36px}.formMargin{margin-top:10px}.tablescroll{overflow:scroll!important}.labelAdd{display:flex;width:auto;margin-right:20px}.logicaloperator{display:flex}.labelRemove{margin-left:auto}.row.bottomrow{margin-top:20px;flex-wrap:nowrap}.row.bottomrow .col-md-6{border:1px solid #adadad;border-radius:5px;padding:20px;margin:0 10px;max-width:49%}.col-md-4.tw0select{display:flex;justify-content:center}.formMargin{padding:20px;position:relative;width:100%;height:100%;border:1px solid #ddd;box-shadow:0 0 5px 1px #00000017}.col-md-4.tw0select .ng-select{min-width:141px}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i1.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i1.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i1.NgControlStatusGroup, selector: "[formGroupName],[formArrayName],[ngModelGroup],[formGroup],form:not([ngNoForm]),[ngForm]" }, { kind: "directive", type: i1.FormGroupDirective, selector: "[formGroup]", inputs: ["formGroup"], outputs: ["ngSubmit"], exportAs: ["ngForm"] }, { kind: "directive", type: i1.FormControlName, selector: "[formControlName]", inputs: ["formControlName", "disabled", "ngModel"], outputs: ["ngModelChange"] }, { kind: "component", type: i4.NgSelectComponent, selector: "ng-select", inputs: ["bindLabel", "bindValue", "markFirst", "placeholder", "notFoundText", "typeToSearchText", "addTagText", "loadingText", "clearAllText", "appearance", "dropdownPosition", "appendTo", "loading", "closeOnSelect", "hideSelected", "selectOnTab", "openOnEnter", "maxSelectedItems", "groupBy", "groupValue", "bufferAmount", "virtualScroll", "selectableGroup", "selectableGroupAsModel", "searchFn", "trackByFn", "clearOnBackspace", "labelForId", "inputAttrs", "tabIndex", "readonly", "searchWhileComposing", "minTermLength", "editableSearchTerm", "keyDownFn", "typeahead", "multiple", "addTag", "searchable", "clearable", "isOpen", "items", "compareWith", "clearSearchOnAdd"], outputs: ["blur", "focus", "change", "open", "close", "search", "clear", "add", "remove", "scroll", "scrollToEnd"] }, { kind: "component", type: JsonlogicComponent, selector: "app-jsonlogic", inputs: ["form", "fieldsList", "componentLocation"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: JsonlogicExpressionEditorComponent, decorators: [{
            type: Component,
            args: [{ selector: 'jsonlogic-expression-editor', template: "<div class=\"col-md-12\">\r\n    <!-- <div class=\"row\">\r\n        <div class=\"col-md-1\">&nbsp;</div>\r\n        <div class=\"col-md-1 text-center\">And/Or</div>\r\n        <div class=\"col-md-4 text-center\">Field *</div>\r\n        <div class=\"col-md-1 text-center\">Operator *</div>\r\n        <div class=\"col-md-5 text-center\">Value *</div>\r\n    </div> -->\r\n    <div class=\"formMargin\" *ngFor=\"let group of expressionformArray['controls'];let i=index\">\r\n        <div [formGroup]=\"this.getFormGroup(group)\">\r\n            <div class=\"row toprow\">\r\n              <div class=\"col-md-4 noPadding text-center logicaloperator\">\r\n                <div class=\"labelAdd\">\r\n                  <img [src]=\"plus\" class=\"imgbtn imgadd\" (click)=\"addCheckExpression(i)\"/> <span style=\"font-size: 20px;\">And/Or</span>\r\n                </div>\r\n                <div *ngIf=\"i!=0\">\r\n                  <ng-select class=\"form-controls\" [id]=\"'logicaloperator'+i\" [items]=\"logicalOperatorList\"\r\n                      ngDefaultControl bindLabel=\"label\" [clearable]=\"false\" bindValue=\"value\"\r\n                      placeholder=\"And/Or\" formControlName=\"logicalOperator\">\r\n                  </ng-select>\r\n              </div>\r\n\r\n            </div>\r\n\r\n            <div class=\"col-md-4 tw0select\">\r\n                <!-- <div *ngIf=\"i==0\">&nbsp;</div> -->\r\n\r\n                <ng-select [ngClass]=\"{errorborder: this.checkerror(group.get('operator'))}\" (open)=\"filterOperatorList(i)\" class=\"form-controls\" [id]=\"'operator'+i\"\r\n                [items]=\"filtered_operatorList\" bindLabel=\"label\" [clearable]=\"false\" bindValue=\"value\"\r\n                placeholder=\"operator\" formControlName=\"operator\">\r\n            </ng-select>\r\n            </div>\r\n            <div class=\"col-md-4\" >\r\n\r\n\r\n              <div class=\"labelRemove\" *ngIf=\"expressionformArray['length']>1\">\r\n                <img [src]=\"minus\" class=\"imgbtn imgminus\" (click)=\"removecheckExpresssion(i,group)\"/>\r\n        </div>\r\n          </div>\r\n\r\n            </div>\r\n            <div class=\"row bottomrow\">\r\n\r\n\r\n                <div class=\"col-md-6\" [ngClass]=\"{'tablescroll': group?.get('leftComponent')?.get('parameters')?.value?.length>0}\"  *ngIf=\"group?.get('leftComponent')!=undefined\">\r\n                  <table style=\"width: 100%; overflow:scroll;\">\r\n                    <app-jsonlogic  [componentLocation]=\"'left'\" [fieldsList]=\"variables\"\r\n                        [form]=\"this.getFormGroup(group.get('leftComponent'))\">\r\n                    </app-jsonlogic>\r\n                  </table>\r\n                </div>\r\n\r\n\r\n                <div class=\"col-md-6\" [ngClass]=\"{'tablescroll': group?.get('rightComponent')?.get('parameters')?.value?.length>0}\"  *ngIf=\"group.get('fieldtype')?.value!=null && group?.get('rightComponent')!=undefined \">\r\n                   <table style=\"width: 100%; overflow:scroll;\">\r\n                    <app-jsonlogic #jsoneditor [componentLocation]=\"'right'\" [fieldsList]=\"variables\"\r\n                        [form]=\"this.getFormGroup(group.get('rightComponent'))\">\r\n                    </app-jsonlogic>\r\n                  </table>\r\n                </div>\r\n            </div>\r\n        </div>\r\n    </div>\r\n</div>\r\n", styles: [".errorborder{border:1px solid red!important;border-radius:5px!important;-webkit-border-radius:5px!important;-moz-border-radius:5px!important;-ms-border-radius:5px!important;-o-border-radius:5px!important}.col-md-1.noPadding.text-center{display:flex;justify-content:space-evenly}::ng-deep jsonlogic-expression-editor{margin:20px;display:block}.formMargin{width:100%}.labelAdd,.labelRemove{width:30px;height:30px}.imgbtn{background-repeat:no-repeat;background-position:center;max-width:30px;height:30px;width:100%;background-size:contain;cursor:pointer;position:relative;display:block;margin-inline:10px}.lineone input.form-controls.ng-untouched.ng-pristine.ng-valid{padding:5px 10px;color:#333;background-color:#fff;border-radius:4px;border:1px solid #ccc;min-height:36px}.formMargin{margin-top:10px}.tablescroll{overflow:scroll!important}.labelAdd{display:flex;width:auto;margin-right:20px}.logicaloperator{display:flex}.labelRemove{margin-left:auto}.row.bottomrow{margin-top:20px;flex-wrap:nowrap}.row.bottomrow .col-md-6{border:1px solid #adadad;border-radius:5px;padding:20px;margin:0 10px;max-width:49%}.col-md-4.tw0select{display:flex;justify-content:center}.formMargin{padding:20px;position:relative;width:100%;height:100%;border:1px solid #ddd;box-shadow:0 0 5px 1px #00000017}.col-md-4.tw0select .ng-select{min-width:141px}\n"] }]
        }], ctorParameters: function () { return [{ type: i1.FormBuilder }]; }, propDecorators: { jsonLogic: [{
                type: Input
            }], variables: [{
                type: Input
            }], functions: [{
                type: Input
            }] } });

class JsonLogicEditorModule {
}
JsonLogicEditorModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: JsonLogicEditorModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
JsonLogicEditorModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.1.0", ngImport: i0, type: JsonLogicEditorModule, declarations: [JsonlogicExpressionEditorComponent,
        JsonlogicComponent], imports: [CommonModule,
        ReactiveFormsModule, i3.BsDatepickerModule, FormsModule,
        NgSelectModule], exports: [JsonlogicExpressionEditorComponent] });
JsonLogicEditorModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: JsonLogicEditorModule, providers: [BsDatepickerConfig], imports: [CommonModule,
        ReactiveFormsModule,
        BsDatepickerModule.forRoot(),
        FormsModule,
        NgSelectModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: JsonLogicEditorModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        JsonlogicExpressionEditorComponent,
                        JsonlogicComponent,
                    ],
                    imports: [
                        CommonModule,
                        ReactiveFormsModule,
                        BsDatepickerModule.forRoot(),
                        FormsModule,
                        NgSelectModule
                    ],
                    exports: [
                        JsonlogicExpressionEditorComponent
                    ],
                    providers: [BsDatepickerConfig]
                }]
        }] });

/**
 * Generated bundle index. Do not edit.
 */

export { JsonLogicEditorModule, JsonlogicExpressionEditorComponent };
//# sourceMappingURL=json-logic-editor.mjs.map
