import { AfterViewInit, OnInit } from '@angular/core';
import { AbstractControl, FormArray, FormBuilder, FormControl, FormGroup } from '@angular/forms';
import { ICheckExpressionFieldLookUp, ICheckListExpression, ICustomJsonLogicComponent } from './interfaces/IJsonEditor';
import * as i0 from "@angular/core";
export declare class JsonlogicExpressionEditorComponent implements OnInit, AfterViewInit {
    private fb;
    jsonLogic: string | undefined;
    variables: ICheckExpressionFieldLookUp[];
    functions: ICheckExpressionFieldLookUp[];
    plus: string;
    minus: string;
    JSON_LOGIC: String | undefined;
    JsonLogicObj: any;
    checklistTemplateItemExpressions: ICheckListExpression[];
    filtered_operatorList: any;
    operatorList: {
        type: string[];
        label: string;
        value: string;
    }[];
    expressionformArray: FormArray;
    logicalOperatorList: {
        label: string;
        value: number;
    }[];
    constructor(fb: FormBuilder);
    ngAfterViewInit(): void;
    ngOnInit(): void;
    mergeFunctionIntoVariables(): void;
    SetttingsForVariableAndFunctions(functions: ICheckExpressionFieldLookUp[] | undefined): void;
    constructModelLogic(): void;
    parseJsonLogic(Jobj: any, logic: ICheckListExpression): ICheckListExpression;
    parseComponentLogic(Jobj: any, component: ICustomJsonLogicComponent, name?: string | null | undefined, padding?: number): ICustomJsonLogicComponent;
    constructFormArray(): void;
    add_checkExpressionFormGroup(exp: ICheckListExpression): FormGroup<{
        id: FormControl<number | null>;
        logicalOperator: FormControl<number | null>;
        leftComponent: FormGroup<{
            type: FormControl<string | null | undefined>;
            value: FormControl<any>;
            label: FormControl<string | null | undefined>;
            name: FormControl<string | null | undefined>;
            returnType: FormControl<string | null | undefined>;
            controlType: FormControl<string | null | undefined>;
            padding: FormControl<number | null>;
            parameters: FormArray<FormControl<unknown>>;
        }>;
        operator: FormControl<string | null | undefined>;
        rightComponent: FormGroup<{
            type: FormControl<string | null | undefined>;
            value: FormControl<any>;
            label: FormControl<string | null | undefined>;
            name: FormControl<string | null | undefined>;
            returnType: FormControl<string | null | undefined>;
            controlType: FormControl<string | null | undefined>;
            padding: FormControl<number | null>;
            parameters: FormArray<FormControl<unknown>>;
        }>;
        fieldtype: FormControl<string | null | undefined>;
        transactionType: FormControl<number | null>;
    }>;
    componentFormGroup(logic: ICustomJsonLogicComponent | null | undefined): FormGroup<{
        type: FormControl<string | null | undefined>;
        value: FormControl<any>;
        label: FormControl<string | null | undefined>;
        name: FormControl<string | null | undefined>;
        returnType: FormControl<string | null | undefined>;
        controlType: FormControl<string | null | undefined>;
        padding: FormControl<number | null>;
        parameters: FormArray<FormControl<unknown>>;
    }>;
    addCheckExpression(i: number): void;
    removecheckExpresssion(i: number, group: FormGroup | AbstractControl): void;
    deleteExpression(i: number): void;
    filterOperatorList(i: number): void;
    getLeftComponentType(expression: FormGroup): any;
    getTransactionType(exp: ICheckListExpression): number;
    setValueType(type: any, expression: any): void;
    getJsonLogic(): string | undefined;
    generateExpression(group: FormGroup, controlType: string, fieldtype: string): any;
    getLogicalOperatorKey(lo: any): any;
    getLogicalOperatorValue(key: any): 1 | 0;
    IsISODate(date: string): boolean;
    getFormGroup(group: any): FormGroup<any>;
    consolelogic(): void;
    checkerror(control: any): boolean;
    static ɵfac: i0.ɵɵFactoryDeclaration<JsonlogicExpressionEditorComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<JsonlogicExpressionEditorComponent, "jsonlogic-expression-editor", never, { "jsonLogic": "jsonLogic"; "variables": "variables"; "functions": "functions"; }, {}, never, never, false>;
}
